#!/bin/bash

#   add_database.sh this script can be called by add_client.sh
#   or directly by diss.sh to add a new database
#
#   DISS - Debian Install Server Scripts
#   A set of scripts to automate installation of Servers on Debian
#   (c) 2009 Emmanuel Revah - manu-at-manurevah.com
#
#   This file is part of DISS.
#
#   DISS is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   DISS is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with DISS.  If not, see <http://www.gnu.org/licenses/>.

clear
source /etc/diss/diss.conf
source ${SCRIPTS}/functions.sh

# test if install_base has been done, if not show a message
THISSCRIPT=add_database.sh
DEPENDSTATE=${WEBSTATE}
DEPENDSON="install_lamp"
dependsOn

echo "

###########################
#			  #
#     Add a DataBase      #
#			  #
###########################

"

test ${CLIENT} || CLIENT=0
if [ "${CLIENT}" = "0" ]; then
	# 0 = ${CLIENT} is empty, so either the client 
	# does not exist or the script was launched 
	# without add_client.sh
	pickAclient
fi

getInpute "database name (this script will add ${CLIENT}_ as prefix):" db
SQLBASE=${CLIENT}_${ANSWER}

echo "

#############################
#			    #
#	Confirm stuff	    #
#			    #
#############################

User : ${CLIENT}
Database to be created : ${SQLBASE}
"

# confirm before actually doing anything
echo -n "
 Shall we proceed ? (y/N) : "
read GO
if [ "${GO}" = "y" ] || [ "${GO}" = "Y" ]; then
	echo "Creating database"
	mysql -uroot -p${ROOTSQL} -e "CREATE DATABASE \`${SQLBASE}\`;"
	echo "
 if all went well the database has been created
:]"


# if this script was executed from add_client.sh then we'll let the 
# said script show the infos, else lets show it now

	if [ "${ADDCLIENT}" != "1" ]; then
		clear
		echo " 

########################
#                      #
#     Useful Info      #
#                      #
########################


- MySQL username : ${CLIENT}
- Database name : ${SQLBASE}
- Password : ${CLIENTPASS}
 
- PhpMyAdmin is available at: http://${CLIENTNIMDAURL}

Press enter to go back to DISS menu
"
	read
	exit
	fi
fi
