#!/bin/bash

#   install_mail.sh - install a full mail server with a bunch of crap
#   This install is extremely inspired by http://workaround.org/articles/ispmail-etch/
#
#   DISS - Debian Install Server Scripts
#   A set of scripts to automate installation of Servers on Debian
#   (c) 2009 Emmanuel Revah - manu-at-manurevah.com
#
#   This file is part of DISS.
#
#   DISS is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   DISS is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with DISS.  If not, see <http://www.gnu.org/licenses/>.

# FIXME
#	- check if volatile is already in sources.list
#	- check "change password" plugin in squirrelmail (~ line 350)
#	- is pysieved still required ? (line 411)

clear
source /etc/diss/diss.conf
source ${SCRIPTS}/functions.sh

THISSCRIPT=install_mail.sh
THISSTATE=${MAILSTATE}
installStatus

DEPENDSTATE=${WEBSTATE}
DEPENDSON="install_lamp"
dependsOn

#################
#	INPUTS		#
echo -e "\n
##########################################################

PLEASE READ THIS:

The mail server runs out of mysql, so we will
need to create a mysql user, one just for consulting the
database \"mailuser\" and one for actually adding domains,
users, aliases and etc. \"mailadmin\".  they will mostly
be used by scripts and conf files.

The mail server installation is based on :
http://workaround.org/.

There are a few changes, such as the database structure,
per user filtering policies and the possibility to be a backup MX for others.
For more details check: http://manurevah.com/blah/en/pages/mailboy
(Oh yeah, I integrated a web admin panel)

##########################################################\n"

getInpute "Enter the password for \"mailuser\":" pw
MAILUSERPASS="${ANSWER}"
getInpute "Enter the password for \"mailadmin\":" pw
MAILADMINPASS="${ANSWER}"

echo -ne "\nwe should configure the first domain on the mail server.
we can use the default base domain: ${ADMINSITE} for this,\n\n
Enter domain name (default: ${ADMINSITE}): "
read MAILDOMAIN
: ${MAILDOMAIN:=$ADMINSITE}

echo -ne "IMPORTANT NOTE:
We shall create a mailbox for the main user
This user will also be used to manage all email accounts on this server
and will receive emails from the system.
\nBy default we can use: ${ADMINUSER}  (will become ${ADMINUSER}@${MAILDOMAIN})
what will be the main email account to create ? (default ${ADMINUSER}): "
read MAILADMINUSER
: ${MAILADMINUSER:=$ADMINUSER}

getInpute "Set the password for ${MAILADMINUSER}@${MAILDOMAIN}:" pw
MAILADMINUSERPASS="${ANSWER}"
#	End inputs	#
#################

#####################
#	CONFIRMATION	#
echo "confirm stuff

mail server
- mail server 'user' mysql pass: ${MAILUSERPASS}
- mail server 'admin' mysql pass: ${MAILADMINPASS}

domain:
- mail domain: ${MAILDOMAIN}
- main email account: ${MAILADMINUSER}@${MAILDOMAIN}
- main email password: ${MAILADMINUSERPASS}

Please verify the above information before continuing"
confirmORdie
#	Confirmed		#
#####################

#################
#	APT-GET *	#
if [[ $DEB_ASL == "squeeze" ]]; then
	echo -e "\n# Debian updates (old volatile), useful for ClamAV updates
deb http://ftp.debian.org/debian squeeze-updates main" >> /etc/apt/sources.list
else
	echo -e "\n# volatile stuff for clamav
deb http://volatile.debian.org/debian-volatile lenny/volatile main contrib" >> /etc/apt/sources.list
fi
apt-get update
apt-get upgrade -y
aptitude install -y  dovecot-pop3d dovecot-imapd amavisd-new spamassassin \
clamav-daemon cpio arj zoo nomarch lzop cabextract pax \
squirrelmail-locales squirrelmail-decode squirrelmail python \
squirrelmail-compatibility squirrelmail-quicksave squirrelmail-viewashtml \
patch
DEBIAN_PRIORITY=critical apt-get install -y avelsieve postfix-mysql postfix
squirrelmail-configure --install-plugin avelsieve
squirrelmail-configure --install-plugin quicksave
squirrelmail-configure --install-plugin view_as_html
pear install pear/DB
#	APT-GOT		#
#################

# dirty fix
apt-get remove --purge openbsd-inetd -y
rm /etc/inetd.conf
apt-get install openbsd-inetd -y

# SPAMASSASSIN STUFF FIXME- NEEDS CHECKING
sed -i "s/ENABLED=0/ENABLED=1/" /etc/default/spamassassin

# change alias root: user1 to  ${MAILADMINUSER}@${MAILDOMAIN}
cp /etc/aliases /etc/aliases.diss-BKP
sed -i "s/root: `grep root: /etc/aliases|cut -d " " -f 2`/root: ${MAILADMINUSER}@${MAILDOMAIN}/" /etc/aliases
newaliases

################
# WEBMAIL USER #
WEBMAILPASS=` mkpasswd -s ${CLIENTPASS} -5`
WEBMAILNIXPASS=$(perl -e 'print crypt($ARGV[0], "password")' ${WEBMAILPASS})
useradd --shell /bin/false -p ${WEBMAILNIXPASS} webmail -d /home/www/html/webmail
chown root:www-data /home/www/html/webmail

#chown -R root:webmail /home/www/html/webmail/system/
############
chown webmail:www-data /home/www/html/webmail/system/
chmod 750 /home/www/html/webmail/system/

# awstats dir
mkdir -p /home/www/html/webmail/system/awstats/
chown www-data:webmail /home/www/html/webmail/system/awstats/
chmod 750 /home/www/html/webmail/system/

# backup dir
mkdir -p /home/www/html/webmail/backup
chmod 750 /home/www/html/webmail/backup/
chown root:root /home/www/html/webmail/backup/

mkdir -p /home/www/html/webmail/system/apache_logs/
chown root:www-data /home/www/html/webmail/system/apache_logs/
chmod 750 /home/www/html/webmail/system/apache_logs/
#########

mkdir /home/www/html/webmail/system/php
cp /etc/php5/cgi/php.ini /home/www/html/webmail/system/php/
ln -s /etc/php5/cgi/conf.d/ /home/www/html/webmail/system/php/
sed -i "s/display_errors = On/display_errors = Off/" /home/www/html/webmail/system/php/php.ini

mkdir /var/www/php-fcgi-scripts/webmail
echo "#!/bin/bash
#PHPRC=/etc/php5/cgi/
PHPRC=/home/www/html/webmail/system/php/
export PHPRC
export PHP_FCGI_MAX_REQUESTS=5000
export PHP_FCGI_CHILDREN=2
exec /usr/lib/cgi-bin/php" > /var/www/php-fcgi-scripts/webmail/php-fcgi-starter
chown -R webmail:webmail /var/www/php-fcgi-scripts/webmail
chmod 750 /var/www/php-fcgi-scripts/webmail/php-fcgi-starter
# WEBMAIL USER #
################

#################
#	MAILBOY		#
MAILBOYVERSION="mailboy_0.4.6"
cd /home/www/html/webmail/
cp /usr/local/diss/softs/${MAILBOYVERSION}.tar.gz .
tar zxvf ${MAILBOYVERSION}.tar.gz
mv ${MAILBOYVERSION} mailboy
rm ${MAILBOYVERSION}.tar.gz
cd mailboy
cp config.php.example config.php
chmod 400 config.php
chgrp webmail config.php
cp db_config.php.example db_config.php
sed -i "s/super_crazy_password/${MAILADMINPASS}/" db_config.php
chmod 400 db_config.php
#chgrp webmail db_config.php
chown -R webmail:webmail /home/www/html/webmail/mailboy

# create mailboy db file
mysqladmin -p${ROOTSQL} create mailserver
echo "GRANT SELECT ON mailserver.* TO mailuser@localhost IDENTIFIED BY '${MAILUSERPASS}';
GRANT SELECT , INSERT , UPDATE , DELETE , CREATE , DROP , INDEX , ALTER ,
CREATE TEMPORARY TABLES , CREATE VIEW , SHOW VIEW , CREATE
ROUTINE, ALTER ROUTINE, EXECUTE ON mailserver . * TO 'mailadmin'@'localhost'
IDENTIFIED BY '${MAILADMINPASS}';
FLUSH PRIVILEGES ;
USE mailserver;" > /root/mailboy_db.sql
cat database.sql >> /root/mailboy_db.sql
# add default admin user and aliases - + add default amavis policies
echo "-- insert ${MAILDOMAIN} into table domain
INSERT INTO virtual_domains (id, name) VALUES (1, '${MAILDOMAIN}');
INSERT INTO virtual_users (id, domain_id, user, password, admin) VALUES (1, 1, '${MAILADMINUSER}', MD5('${MAILADMINUSERPASS}'), 1);
INSERT INTO virtual_aliases (id, domain_id, source, destination) VALUES (1, 1, 'postmaster', '${MAILADMINUSER}@${MAILDOMAIN}'),
(2, 1, 'webmaster', '${MAILADMINUSER}@${MAILDOMAIN}');
INSERT INTO policy VALUES (
1,'anti virus/spam','N','N','N','N','N','N','N','N','Y','',-1000,5,10),(
2,'anti virus/spam - withouth subject change','N','N','N','N','N','N','N','N','N','',-1000,5,10),(
3,'no scan','Y','Y','Y','Y','Y','Y','Y','Y','N','',10000,10000,10000);" >> /root/mailboy_db.sql

# MAILBY DB -> GO
mysql -p${ROOTSQL} < /root/mailboy_db.sql
rm /root/mailboy_db.sql
#	MAILBOY		#
#################

#################
#	POSTFIX		#
echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT 1 FROM virtual_domains WHERE name='%s'" > /etc/postfix/mysql-virtual-mailbox-domains.cf
postconf -e virtual_mailbox_domains=mysql:/etc/postfix/mysql-virtual-mailbox-domains.cf
SQLTEST=$(postmap -q ${MAILDOMAIN} mysql:/etc/postfix/mysql-virtual-mailbox-domains.cf)
if [ "${SQLTEST}" != "1" ]; then
	echo -e "\n\nERROR: there is a problem, the domain ${MAILDOMAIN} has not been inserted in the database
please fix this. (test = 'postmap -q ${MAILDOMAIN} mysql:/etc/postfix/mysql-virtual-mailbox-domains.cf'
this command should return: \"1\"
you can press enter when ready to continue\n"
	read
fi
groupadd -g 5000 vmail && useradd -g vmail -u 5000 vmail -d /home/vmail -m -k /dev/null
postconf -e virtual_uid_maps=static:5000
postconf -e virtual_gid_maps=static:5000
echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT 1 FROM view_users WHERE email='%s'" > /etc/postfix/mysql-virtual-mailbox-maps.cf
postconf -e virtual_mailbox_maps=mysql:/etc/postfix/mysql-virtual-mailbox-maps.cf
echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT destination FROM view_aliases WHERE email='%s'" > /etc/postfix/mysql-virtual-alias-maps.cf
echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT email FROM view_users WHERE email='%s'" > /etc/postfix/mysql-email2email.cf
postconf -e virtual_alias_maps=mysql:/etc/postfix/mysql-virtual-alias-maps.cf,mysql:/etc/postfix/mysql-email2email.cf
# POSTFIX - BACKUP MX stuff
echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT domain FROM relay_domains WHERE domain like '%s'" > /etc/postfix/mysql-relay-domains.cf
echo -e "\n#The following 2 lines are for BACKUP MX stuff for friend's domains" >> /etc/postfix/main.cf
postconf -e relay_domains=mysql:/etc/postfix/mysql-relay-domains.cf
postconf -e relay_recipient_maps=
# Extra stuff from Mailboy - ip/sender restrictions
echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT state FROM domain_access WHERE domain = '%s'" > mysql-smtpd_sender_restrictions.cf
#postconf -e smtpd_sender_restrictions=mysql:/etc/postfix/mysql-smtpd_sender_restrictions.cf
echo "user = mailuser
password = ${MAILUSERPASS}
hosts = 127.0.0.1
dbname = mailserver
query = SELECT state FROM ip_access WHERE ip = '%s'" > mysql-ip-access.cf

# Set permissions on postfix files
chgrp postfix /etc/postfix/mysql-*.cf
chmod u=rw,g=r,o= /etc/postfix/mysql-*.cf
cp /etc/postfix/master.cf /etc/postfix/master.cf.diss-BKP
cp ${DEFCONFS}/mail/master.cf /etc/postfix/master.cf

echo -ne "\nLet's create a certificate for Postfix.\n
\nnote: this will be used by clients who use this server to send emails
 -> press enter when ready"
read
# POSTFIX CERTIFICATE
openssl req -new -x509 -days 730 -nodes -out /etc/ssl/certs/postfix.pem -keyout /etc/ssl/private/postfix.pem
chmod o= /etc/ssl/private/postfix.pem
postconf -e smtpd_tls_cert_file=/etc/ssl/certs/postfix.pem
postconf -e smtpd_tls_key_file=/etc/ssl/private/postfix.pem
# more confstuff later: postfix <-> dovecot && postfix <-> clamav
#	POSTFIX		#
#################

#################
#	DOVECOT		#
postconf -e virtual_transport=dovecot
postconf -e dovecot_destination_recipient_limit=1
cp /etc/dovecot/dovecot.conf /etc/dovecot/dovecot.conf.diss-BKP
if [[ $DEB_ASL == "squeeze" ]]; then
	DOVECOT_SIEVE_SQUEEZE_1="mail_plugins = sieve"
	DOVECOT_SIEVE_SQUEEZE_2="sieve=~/.dovecot.sieve
	sieve_dir=~/sieve"
else
	DOVECOT_SIEVE_LENNY_1="# Comment/delete the 2 following lines on Debian Squeeze
	sieve=~/.dovecot.sieve
	sieve_storage=~/sieve"
	DOVECOT_SIEVE_LENNY_2="# On Debian Squeeze replace the following line with: mail_plugins = sieve
	mail_plugins = cmusieve"
	DOVECOT_SIEVE_LENNY_3="# UNcomment the 2 following lines on Debian Squeeze
	#sieve=~/.dovecot.sieve
	#sieve_dir=~/sieve"
fi
echo "# Dovecot.conf - generated by DISS.
#
# Check dovecot.conf.diss-BKP for default config
# and other options and comments

protocols = imap imaps pop3 pop3s managesieve
log_timestamp = \"%Y-%m-%d %H:%M:%S \"
ssl_cert_file = /etc/ssl/certs/dovecot.pem
ssl_key_file = /etc/ssl/private/dovecot.pem
mail_location = maildir:/home/vmail/%d/%n/maildir
mail_privileged_group = mail
protocol imap {
}
protocol pop3 {
	pop3_uidl_format = %08Xu%08Xv
}
protocol managesieve {
	$DOVECOT_SIEVE_LENNY_1
}
protocol lda {
	log_path = /home/vmail/dovecot-deliver.log
	auth_socket_path = /var/run/dovecot/auth-master
	postmaster_address = @postmaster@${MAILDOMAIN}
	$DOVECOT_SIEVE_LENNY_2
	$DOVECOT_SIEVE_SQUEEZE_1
	global_script_path = /home/vmail/globalsieverc
}
auth default {
	mechanisms = plain login
	passdb sql {
		args = /etc/dovecot/dovecot-sql.conf
		}
	userdb passwd {
	}
	userdb sql {
		args = /etc/dovecot/dovecot-sql.conf
	}
	user = root
	socket listen {
		master {
			path = /var/run/dovecot/auth-master
			mode = 0600
			user = vmail
		}
		client {
			path = /var/spool/postfix/private/auth
			mode = 0660
			user = postfix
			group = postfix
		}
	}
}
dict {
}
plugin {
	$DOVECOT_SIEVE_LENNY_3
	$DOVECOT_SIEVE_SQUEEZE_2
}" > /etc/dovecot/dovecot.conf
chmod 640 /etc/dovecot/dovecot.conf
chown root:vmail /etc/dovecot/dovecot.conf
cp /etc/dovecot/dovecot-sql.conf /etc/dovecot/dovecot-sql.conf.diss-BKP
echo "driver = mysql
connect = host=127.0.0.1 dbname=mailserver user=mailuser password=${MAILUSERPASS}
default_pass_scheme = PLAIN-MD5
password_query = SELECT email as user, password FROM view_users WHERE email='%u';
user_query = SELECT CONCAT('/home/vmail/',CONCAT(SUBSTRING_INDEX(email,'@',-1),'/',SUBSTRING_INDEX(email,'@',1))) AS home, 5000 AS uid, 5000 AS gid, CONCAT('maildir:storage=',quota_kb,':messages=',quota_messages) AS quota FROM view_users WHERE email='%u';" > /etc/dovecot/dovecot-sql.conf
mysql -p${ROOTSQL} -e "flush privileges"
# DOVECOT CERTIFICATE
echo -ne "\nAnd a certificate for Dovecot.\n
 -> press enter when ready"
read
openssl req -new -x509 -days 730 -nodes -out /etc/ssl/certs/dovecot.pem -keyout /etc/ssl/private/dovecot.pem
/etc/init.d/dovecot restart
postconf -e smtpd_sasl_type=dovecot
postconf -e smtpd_sasl_path=private/auth
postconf -e smtpd_sasl_auth_enable=yes
postconf -e smtpd_recipient_restrictions=permit_mynetworks,permit_sasl_authenticated,reject_unauth_destination
# create global sieve file to filter out spam for all accounts
cp ${DEFCONFS}/mail/globalsieverc  /home/vmail/
#	DOVECOT		#
#################

#####################
#	SpamAssassin	#
cp /etc/spamassassin/local.cf /etc/spamassassin/local.cf.diss-BKP
cp ${DEFCONFS}/mail/local.cf /etc/spamassassin/local.cf
/etc/init.d/spamassassin restart
#	SpamAssassin	#
#####################

#################
#	CLAMAV		#
cp ${DEFCONFS}/mail/20-debian_defaults /etc/amavis/conf.d/20-debian_defaults
cp ${DEFCONFS}/mail/15-content_filter_mode /etc/amavis/conf.d/15-content_filter_mode
#/etc/init.d/amavis restart
postconf -e content_filter=smtp-amavis:[127.0.0.1]:10024
postconf -e receive_override_options=no_address_mappings
adduser clamav amavis
sed -i "s/PhishingScanURLs true/#PhishingScanURLs true/" /etc/clamav/clamd.conf
sed -i "s/PhishingRestrictedScan true/#PhishingRestrictedScan true/" /etc/clamav/clamd.conf
sed -i "s/PhishingAlwaysBlockSSLMismatch false/#PhishingAlwaysBlockSSLMismatch false/" /etc/clamav/clamd.conf
sed -i "s/PhishingAlwaysBlockCloak false/#PhishingAlwaysBlockCloak false/" /etc/clamav/clamd.conf
sed -i "s/DetectPUA false/#DetectPUA false/" /etc/clamav/clamd.conf
echo "use strict;

@lookup_sql_dsn = (
    ['DBI:mysql:database=mailserver;host=127.0.0.1;port=3306',
     'mailuser',
     '${MAILUSERPASS}']);

\$sql_select_policy = 'SELECT *,email FROM view_users,policy'.
' WHERE (view_users.policy_id=policy.id)'.
' AND email IN (%k)';

\$sql_select_white_black_list = undef;

1;" > /etc/amavis/conf.d/50-user

# should maybe restart everyone just in case :]
postfix reload
/etc/init.d/amavis restart
/etc/init.d/clamav-daemon restart
# create spam and ham learn folders and cron a script or something
mkdir -p /home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.spam
mkdir -p /home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.spam.spam-learn
mkdir -p /home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.spam.ham-learn
echo -e "INBOX.spam\nINBOX.spam.spam-learn\nINBOX.spam.ham-learn" >> /home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/subscriptions
chown -R vmail:vmail /home/vmail/${MAILDOMAIN}/
chmod -R 700 /home/vmail/${MAILDOMAIN}/
echo "#!/bin/bash

SADIR=/var/lib/amavis/.spamassassin
DBPATH=/var/lib/amavis/.spamassassin/bayes
SPAMFOLDERS=\"\
	/home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.spam.spam-Learn \
	/home/vmail/*/*/maildir/.INBOX.spam/
    \"
HAMFOLDERS=\"\
	/home/vmail/${MAILDOMAIN}/${MAILADMINUSER}/maildir/.INBOX.spam.ham-Learn \
    \"

for spamfolder in \$SPAMFOLDERS ; do \
    echo Learning spam from \$spamfolder ; \
    nice sa-learn --spam --showdots --dbpath \$DBPATH \$spamfolder
done

for hamfolder in \$HAMFOLDERS ; do \
    echo Learning ham from \$hamfolder ; \
    nice sa-learn --ham --showdots --dbpath \$DBPATH \$hamfolder
done

chown -R amavis:amavis \$SADIR

sa-learn --dbpath /var/lib/amavis/.spamassassin/bayes --dump magic
exit" >> /usr/local/sbin/sa-learn-diss.sh
chmod +x /usr/local/sbin/sa-learn-diss.sh
echo "0 8 * * *	root	/usr/local/sbin/sa-learn-diss.sh" >> /etc/crontab
#	CLAMAV		#
#################

#####################
#	SQUIRRELMAIL	#
ln -s /usr/share/squirrelmail/ /home/www/html/webmail/skwirrel

dissBackupfile /usr/share/squirrelmail/config/config.php
cp ${DEFCONFS}/mail/squirrel_config.php /usr/share/squirrelmail/config/config.php
cp /etc/squirrelmail/default_pref /etc/squirrelmail/default_pref.diss-BKP
cp ${DEFCONFS}/mail/squirrel_default_pref /etc/squirrelmail/default_pref
cp /etc/squirrelmail/quicksave-config.php /etc/squirrelmail/quicksave-config.php.diss-BKP
cp ${DEFCONFS}/mail/squirrel_quicksave-config.php /etc/squirrelmail/quicksave-config.php
cp /usr/local/diss/nimda/favicon.ico /usr/share/squirrelmail/

mkdir -p /home/www/html/webmail/outside-html/squirrelmail/data/
mkdir -p /home/www/html/webmail/outside-html/squirrelmail/attach/
chmod 750 /home/www/html/webmail/outside-html/
echo "Deny from All" > /home/www/html/webmail/outside-html/squirrelmail/data/.htaccess
chmod 750 /home/www/html/webmail/outside-html/squirrelmail/data/
chmod 640 /home/www/html/webmail/outside-html/squirrelmail/data/.htaccess
chown -R webmail:www-data /home/www/html/webmail/outside-html/

# take care of the plugins
cp /usr/local/diss/squirrelmail/*.tar.gz /usr/share/squirrelmail/plugins/
cd /usr/share/squirrelmail/plugins/
for SQPLUGIN in `ls /usr/share/squirrelmail/plugins/*.tar.gz`; do tar zxvf ${SQPLUGIN}; done
rm /usr/share/squirrelmail/plugins/*.tar.gz
cp username/config.php.sample username/config.php
cp avelsieve/config/config_sample.php avelsieve/config/config.php
if [[ $DEB_ASL == "squeeze" ]]; then
	sed -i "s/4190/2000/" avelsieve/config/config.php
fi
cp ${DEFCONFS}/mail/squirrel-themes/* /usr/share/squirrelmail/themes/
cp ${DEFCONFS}/mail/vlogin_config.php vlogin/data/config.php

# APACHE
echo "<VirtualHost *:80>
	ServerName mail.${ADMINSITE}
	ServerAlias mail.*
	ServerAlias webmail.*
	DocumentRoot /home/www/html/webmail/skwirrel

	SuexecUserGroup webmail webmail
	<Directory /home/www/html/webmail/skwirrel>
		Options +ExecCGI
		AllowOverride All
		AddHandler fcgid-script .php
		FCGIWrapper /var/www/php-fcgi-scripts/webmail/php-fcgi-starter .php
		Order allow,deny
		Allow from all
	</Directory>

	Alias /mailboy \"/home/www/html/webmail/mailboy/\"
	<Directory /home/www/html/webmail/mailboy/>
		Options +ExecCGI
		AllowOverride All
		AddHandler fcgid-script .php
		FCGIWrapper /var/www/php-fcgi-scripts/webmail/php-fcgi-starter .php
		Order allow,deny
		Allow from all
	</Directory>

	CustomLog /home/www/html/webmail/system/apache_logs/webmail.log combined
	CustomLog /var/log/apache2/global.log combined
</VirtualHost>

<VirtualHost *:443>
	ServerName mail.${ADMINSITE}
	ServerAlias mail.*
	ServerAlias webmail.*
	SSLEngine on
	SSLCertificateFile /etc/apache2/apache.pem
	DocumentRoot /home/www/html/webmail/skwirrel

	SuexecUserGroup webmail webmail
	<Directory /home/www/html/webmail/skwirrel>
		Options +ExecCGI
		AllowOverride All
		AddHandler fcgid-script .php
		FCGIWrapper /var/www/php-fcgi-scripts/webmail/php-fcgi-starter .php
		Order allow,deny
		Allow from all
	</Directory>

	Alias /mailboy \"/home/www/html/webmail/mailboy/\"
	<Directory /home/www/html/webmail/mailboy/>
		Options +ExecCGI
		AllowOverride All
		AddHandler fcgid-script .php
		FCGIWrapper /var/www/php-fcgi-scripts/webmail/php-fcgi-starter .php
		Order allow,deny
		Allow from all
	</Directory>

	CustomLog /home/www/html/webmail/system/apache_logs/webmail.log combined
	CustomLog /var/log/apache2/global.log combined
</VirtualHost>" > /etc/apache2/sites-available/webmail_squirrelmail
a2ensite webmail_squirrelmail
/etc/init.d/apache2 reload
#	SQUIRRELMAIL	#
#####################

#################
#	AWSTATS		#
# WEBMAIL STATS
echo  "LogFile=\"/home/www/html/webmail/system/apache_logs/webmail.log\"
SiteDomain=\"webmail.${ADMINSITE}\"
HostAliases=\"mail.*\"
AllowAccessFromWebToAuthenticatedUsersOnly=1
AllowAccessFromWebToFollowingAuthenticatedUsers=\"${ADMINUSER}\"
DefaultFile=\"index.html\"
ShowFlagLinks=\"en de fr\"
Lang=\"en\"
DirData=\"/home/www/html/webmail/system/awstats/\"
Include \"include.conf\"" > /etc/awstats/awstats.webmail.conf
sed -i "s/<!--REPLACED_BY_WEBMAIL_STATS-->/<li><a href=\"\/awstats\/awstats.pl?config=webmail\">Webmail statistics (for all domains with http or https)<\/a><\/li>/" ${ADMINNIMDAPATH}/index.php

# MAIL SERVER STATS
cp ${DEFCONFS}/awstats/awstats.mail.conf /etc/awstats/
sed -i "s/SiteDomain=/SiteDomain=\"mail.${ADMINSITE}\"/" /etc/awstats/awstats.mail.conf
sed -i "s/AllowAccessFromWebToFollowingAuthenticatedUsers=/AllowAccessFromWebToFollowingAuthenticatedUsers=\"${ADMINUSER}\"/" /etc/awstats/awstats.mail.conf
sed -i "s#<!--REPLACED_WHEN_INSTALLING_MAIL_SERVER-->#<h2>Email Administration</h2>\n\
<ul>\n\
	<li><a href=\"https://mail.${ADMINSITE}/mailboy/\">Mailboy - Mail server administration<\/a></li>\n\
	<li><a href=\"/awstats/awstats.pl?config=mail\">Mail server statistics</a></li>\n\
</ul>#" ${ADMINNIMDAPATH}/index.php
#	AWSTATS		#
#################

# mark as done
sed -i "s/MAILSTATE=\"not installed\"/MAILSTATE=\"done\"/" ${DISSETC}/diss.conf

# firewall stuff - add new ports to diss.conf and restart firewall it is installed
NEWTCPPORTS="${ARNO_OPEN_TCP} 25 110 143 465 993 995"
sed -i "s/ARNO_OPEN_TCP=\"${ARNO_OPEN_TCP}\"/ARNO_OPEN_TCP=\"${NEWTCPPORTS}\"/" ${DISSETC}/diss.conf
if [ -a "/etc/arno-iptables-firewall/debconf.cfg" ]; then
	source /etc/arno-iptables-firewall/debconf.cfg
        sed -i "s/DC_OPEN_TCP=\"${DC_OPEN_TCP}\"/DC_OPEN_TCP=\"${NEWTCPPORTS}\"/" /etc/arno-iptables-firewall/debconf.cfg
        /etc/init.d/arno-iptables-firewall restart
fi

echo "
#########################

 stuff you need to know

#########################


domain:
- mail domain: ${MAILDOMAIN}
- main email account: ${MAILADMINUSER}@${MAILDOMAIN}
- main email password: ${MAILADMINUSERPASS}

- To access \"mailboy\" (Admins can admin, users can change passwords and
filter settings) you may use:
	https://mail.${ADMINSITE}/mailboy
	https://webmail.${ADMINSITE}/mailboy
	https://mail.${MAILDOMAIN}
	https://webmail.${MAILDOMAIN}
	http://mail.${MAILDOMAIN}
	[etc...]

- to use the webmail you can goto:
	https://mail.${MAILDOMAIN}
	http://mail.${MAILDOMAIN}
	https://webmail.${MAILDOMAIN}
	http://webmail.${MAILDOMAIN}

  (mail.* and webmail.* is configured in vhost, this means that for any domain
  hosted on this server the subdomain 'mail' and 'webmail' is configured to use
  squirrelmail and mailboy)

Spam and Ham Learning :
to use this feature the user: ${MAILADMINUSER}@${MAILDOMAIN} can subscribe to
.INBOX.Spam.Spam-Learn and .INBOX.Spam.Ham-Learn folders, move emails that
need to be trained there, a Spam learning script will automatically scan and learn
tokens from those IMAP folders once a day (8 am). the emails can be erased after
learning.

[information you don't really need to remember but should keep somewhere.
it is stored in the postfix and dovecot conf files]

mail server
- mail server 'user' mysql pass: ${MAILUSERPASS}
- mail server 'admin' mysql pass: ${MAILADMINPASS}" >> /etc/diss/infos_mail
chmod 600 /etc/diss/infos_mail
echo "`cat /etc/diss/infos_mail`

press enter to return to DISS main menu"
read
exit
