#!/bin/bash

#   install_diss.sh - Installs DISS on your system
#
#   DISS - Debian Install Server Scripts
#   A set of scripts to automate installation of Servers on Debian
#   (c) 2009 Emmanuel Revah - manu-at-manurevah.com
#
#   This file is part of DISS.
#
#   DISS is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   DISS is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with DISS.  If not, see <http://www.gnu.org/licenses/>.

if [ -f "/etc/diss/diss.conf" ]; then
	source /etc/diss/diss.conf
	echo "
######################

It seems DISS version ${VERSION} is already installed
You should check the README for instructions on upgrading
DISS

#########################
"
	exit ;
fi

source diss.conf
clear
echo -ne "
#######################

  DISS installation
  version ${VERSION}

#######################

This script will install DISS.

this simply means we shall :
- copy \"diss\" to /usr/local/diss/
- link /usr/local/diss/diss.sh in /usr/local/sbin/
- create directory /etc/${SOFTNAME} and put diss.conf there

press enter to continue =>"
read

cp -r diss /usr/local/
ln -s /usr/local/${SOFTNAME}/sbin/diss.sh /usr/local/sbin/
chmod +x /usr/local/${SOFTNAME}/sbin/${SOFTNAME}.sh
mkdir /etc/${SOFTNAME}
cp diss.conf /etc/${SOFTNAME}
chmod 600 -R /etc/${SOFTNAME}

echo "

Installation complete.

You may now use the command diss.sh
to install server software and add sites and/or databases

\o/"
